Attribute VB_Name = "M_ChoosePerso"
Option Explicit

Public Sub PersoScreen()
    
    perf.SetMasterVolume 50 * 10
    Call perf.PlaySegment(MusicTheme, 0, 0)
    
    Sintro.SetCurrentPosition 0
    Sintro.Play DSBPLAY_DEFAULT
    
    ckViolet.high = RGB(255, 0, 255)
    ckViolet.low = RGB(255, 0, 255)
    
    Set SBackScreen = CreateSurfaceFromFile(dd, App.path & "\image\backscreen.jpg", ddsdBackScreen)
    Set STitre = CreateSurfaceFromFile(dd, App.path & "\image\titre.bmp", ddsdTitre)
    STitre.SetColorKey DDCKEY_SRCBLT, ckViolet
    Set sSelect = CreateSurfaceFromFile(dd, App.path & "\image\select.bmp", ddsdSelect)
    sSelect.SetColorKey DDCKEY_SRCBLT, ckViolet
    
    Set SeiyaFace = CreateSurfaceFromFile(dd, App.path & "\perso\seiya\seiyav.bmp", ddsdSeiyaFace)
    SeiyaFace.SetColorKey DDCKEY_SRCBLT, ckViolet
    Set ShiryuFace = CreateSurfaceFromFile(dd, App.path & "\perso\shiryu\shiryuv.bmp", ddsdShiryuFace)
    ShiryuFace.SetColorKey DDCKEY_SRCBLT, ckViolet
    
    Set IkkiFace = CreateSurfaceFromFile(dd, App.path & "\perso\ikki\ikkiv.bmp", ddsdIkkiFace)
    IkkiFace.SetColorKey DDCKEY_SRCBLT, ckViolet
    
    Set Shun3aFace = CreateSurfaceFromFile(dd, App.path & "\perso\shun\shunv.bmp", ddsdShun3aFace)
    Shun3aFace.SetColorKey DDCKEY_SRCBLT, ckViolet
    
    Set NachiFace = CreateSurfaceFromFile(dd, App.path & "\perso\nachi\nachiv.bmp", ddsdNachiFace)
    NachiFace.SetColorKey DDCKEY_SRCBLT, ckViolet
    
    Set CygneFace = CreateSurfaceFromFile(dd, App.path & "\perso\cygne\cygnev.bmp", ddsdCygneFace)
    CygneFace.SetColorKey DDCKEY_SRCBLT, ckViolet
    
    
    Set CurseurS = DS.CreateSoundBufferFromFile(App.path & "\son\curseur.wav", bufferDesc, waveFormat)
    
    SelectX = 50
    
    bScreenPerso = True
    
    Do
        
        Backbuffer.Blt ddRect(0, 0, 800, 600), SBackScreen, ddRect(0, 0, 0, 0), DDBLT_WAIT
        Backbuffer.BltFast 170, 100, STitre, ddRect(0, 0, 0, 0), DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
        
        Backbuffer.BltFast 50, 400, SeiyaFace, ddRect(0, 0, 0, 0), DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
        Backbuffer.BltFast 150, 400, ShiryuFace, ddRect(0, 0, 0, 0), DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
        Backbuffer.BltFast 250, 400, IkkiFace, ddRect(0, 0, 0, 0), DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
        Backbuffer.BltFast 350, 400, Shun3aFace, ddRect(0, 0, 0, 0), DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
        Backbuffer.BltFast 450, 400, NachiFace, ddRect(0, 0, 0, 0), DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
        Backbuffer.BltFast 550, 400, CygneFace, ddRect(0, 0, 0, 0), DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
        
        Backbuffer.BltFast SelectX, 400, sSelect, ddRect(0, 0, 0, 0), DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
        
        Call ClavierSelect
        If DIstate.Key(DIK_ESCAPE) Then Call Ending
        
        Primary.Flip Nothing, DDFLIP_WAIT
        
        DoEvents
    Loop Until bScreenPerso = False
    
    Call LoadPerso

End Sub

Public Sub LoadPerso()
    
    Dim temp As Integer
    
    'Chargement des personnages
        
    If SelectX = 50 Then
        Call LoadSeiya
        Player = Seiya
        Player.Name = "Seiya"
        Seiya.SSpecial.Play DSBPLAY_DEFAULT
    ElseIf SelectX = 150 Then
        Call LoadShiryu
        Player = Shiryu
        Player.Name = "Shiryu"
        Player.SSpecial.Play DSBPLAY_DEFAULT
    ElseIf SelectX = 250 Then
        Call LoadIkki
        Player = Ikki
        Player.Name = "Ikki"
        Player.SSpecial.Play DSBPLAY_DEFAULT
    ElseIf SelectX = 350 Then
        Call LoadShun
        Player = Shun
        Player.Name = "Shun"
        Player.SSpecial.Play DSBPLAY_DEFAULT
    ElseIf SelectX = 450 Then
        Call LoadNachi
        Player = Nachi
        Player.Name = "Nachi"
        Player.SSpecial.Play DSBPLAY_DEFAULT
    ElseIf SelectX = 550 Then
        Call LoadCygne
        Player = Cygne
        Player.Name = "Cygne Noir"
        Player.SSpecial.Play DSBPLAY_DEFAULT
    End If
    Randomize
    temp = Int((5 - 1 + 0) * Rnd + 0)
    
    If temp = 0 Then
        Call LoadSeiya
        ComWicked = Seiya
        ComWicked.Name = "Seiya"
    ElseIf temp = 1 Then
        Call LoadShiryu
        ComWicked = Shiryu
        ComWicked.Name = "Shiryu"
    ElseIf temp = 2 Then
        Call LoadIkki
        ComWicked = Ikki
        ComWicked.Name = "Ikki"
    ElseIf temp = 3 Then
        Call LoadShun
        ComWicked = Shun
        ComWicked.Name = "Shun"
    ElseIf temp = 4 Then
        Call LoadNachi
        ComWicked = Nachi
        ComWicked.Name = "Nachi"
    ElseIf temp = 4 Then
        Call LoadCygne
        ComWicked = Cygne
        ComWicked.Name = "Cygne Noir"
    End If
    
    PlayerX = 250
    PlayerY = Player.PositionY.Wait
    PlayerLife = 300
    PlayerCosmos = 225
    PicPlayer = 0
        
    WickedX = 400
    WickedY = ComWicked.PositionY.Wait
    WickedLife = 500
    WickedCosmos = 575
    Wicked = 0
    
    RoundEndTime = 0
    
    Call ErasePerso(Seiya)
    Call ErasePerso(Shiryu)
    Call ErasePerso(Ikki)
    Call ErasePerso(Shun)
    Call ErasePerso(Nachi)
    Call ErasePerso(Cygne)
    
    NbrBackGround = Int((4 - 0 + 1) * Rnd + 0)
    
    bRunning = True

    Call perf.Stop(MusicTheme, segstate, 0, 0)
    Sintro.Stop
    Call Rendu
    
End Sub


Public Sub ClavierSelect()
    DIdevice.GetDeviceStateKeyboard DIstate
    
    If (DIstate.Key(DIK_RIGHT)) And (SelectX < 500) Then
        
        TimerChoose = dx.TickCount
        
        If TimerChoose_State = 0 Then
            TimerChoose_2 = dx.TickCount
            TimerChoose_State = 1
        End If
        
        If TimerChoose - TimerChoose_2 > 50 Then
            TimerChoose_State = 0
            SelectX = SelectX + 100
            CurseurS.Play DSBPLAY_DEFAULT
        End If
    End If
    If (DIstate.Key(DIK_LEFT)) And (SelectX > 50) Then
        
        TimerChoose = dx.TickCount
        
        If TimerChoose_State = 0 Then
            TimerChoose_2 = dx.TickCount
            TimerChoose_State = 1
        End If
        
        If TimerChoose - TimerChoose_2 > 50 Then
            TimerChoose_State = 0
            SelectX = SelectX - 100
            CurseurS.Play DSBPLAY_DEFAULT
        End If
    End If
    If DIstate.Key(DIK_RETURN) Then bScreenPerso = False
End Sub
