Attribute VB_Name = "M_Function"
Option Explicit

Public Sub ErasePerso(perso As perso)
    Erase perso.Back
    Erase perso.Defend
    Erase perso.Die
    Erase perso.Jump
    Erase perso.LFoot
    Erase perso.LHand
    Erase perso.Move
    Erase perso.RFoot
    Erase perso.RHand
    Erase perso.Wait
    Erase perso.Loading
    Erase perso.SFoot
End Sub

Public Sub DrawPlayer(StepX As Integer, StepY As Integer, MaxPic As Integer, Movement As String, PlayerState As String)
    POneHit = False
    If Player.State <> PlayerState Then
        Player.State = PlayerState
        PicPlayer = 0
        POneHit = True
    End If
    
    If PicPlayer = MaxPic Then
        PicPlayer = 0
        If Player.State = "s" Then Player.SDie.Play DSBPLAY_DEFAULT
        Player.State = "w"
    End If
    
    If StepX < 0 Then
        If PlayerX - StepX > 20 Then
            PlayerX = PlayerX + StepX
        End If
    Else
        If (PlayerX + 70 + StepX) < 710 Then
            PlayerX = PlayerX + StepX
        End If
    End If
    
    If StepY < 0 Then
        If PlayerY + StepY > 65 Then PlayerY = PlayerY + StepY
    Else
        If PlayerY + StepY < 150 Then PlayerY = PlayerY + StepY
    End If
    
    If PicPlayer > MaxPic Then PicPlayer = 0
    
    Select Case Movement
    
    Case "jump"
        If PlayerX < WickedX Then
            Backbuffer.BltFast PlayerX, PlayerY, Player.Jump(PicPlayer).Surface, ddRect(0, 0, 0, 0), DDBLTFAST_SRCCOLORKEY Or DDBLTFAST_WAIT
        Else
            Backbuffer.BltFx ddRect(PlayerX, PlayerY, PlayerX + Player.Jump(PicPlayer).ddsdSurface.lWidth, PlayerY + Player.Jump(PicPlayer).ddsdSurface.lHeight), Player.Jump(PicPlayer).Surface, ddRect(0, 0, 0, 0), DDBLT_KEYSRC Or DDBLT_DDFX Or DDBLT_WAIT, BltFxRevert
        End If
    Case "right foot"
        PlayerY = Player.PositionY.RFoot
        If PlayerX < WickedX Then
            If PlayerX + 70 >= WickedX Then PlayerX = PlayerX - StepX
            Backbuffer.BltFast PlayerX, PlayerY, Player.RFoot(PicPlayer).Surface, ddRect(0, 0, 0, 0), DDBLTFAST_SRCCOLORKEY Or DDBLTFAST_WAIT
        Else
            If PlayerX - 20 <= WickedX Then PlayerX = PlayerX - StepX
            Backbuffer.BltFx ddRect(PlayerX, PlayerY, PlayerX + Player.RFoot(PicPlayer).ddsdSurface.lWidth, PlayerY + Player.RFoot(PicPlayer).ddsdSurface.lHeight), Player.RFoot(PicPlayer).Surface, ddRect(0, 0, 0, 0), DDBLT_KEYSRC Or DDBLT_DDFX Or DDBLT_WAIT, BltFxRevert
        End If
    Case "left foot"
        PlayerY = Player.PositionY.LFoot
        If PlayerX < WickedX Then
            If PlayerX + 70 >= WickedX Then PlayerX = PlayerX - StepX
            Backbuffer.BltFast PlayerX, PlayerY, Player.LFoot(PicPlayer).Surface, ddRect(0, 0, 0, 0), DDBLTFAST_SRCCOLORKEY Or DDBLTFAST_WAIT
        Else
            If PlayerX - 20 <= WickedX Then PlayerX = PlayerX - StepX
            Backbuffer.BltFx ddRect(PlayerX, PlayerY, PlayerX + Player.LFoot(PicPlayer).ddsdSurface.lWidth, PlayerY + Player.LFoot(PicPlayer).ddsdSurface.lHeight), Player.LFoot(PicPlayer).Surface, ddRect(0, 0, 0, 0), DDBLT_KEYSRC Or DDBLT_DDFX Or DDBLT_WAIT, BltFxRevert
        End If
    Case "right hand"
        PlayerY = Player.PositionY.RHand
        If PlayerX < WickedX Then
            If PlayerX + 70 >= WickedX Then PlayerX = PlayerX - StepX
            Backbuffer.BltFast PlayerX, PlayerY, Player.RHand(PicPlayer).Surface, ddRect(0, 0, 0, 0), DDBLTFAST_SRCCOLORKEY Or DDBLTFAST_WAIT
        Else
            If PlayerX - 20 <= WickedX Then PlayerX = PlayerX - StepX
            Backbuffer.BltFx ddRect(PlayerX, PlayerY, PlayerX + Player.RHand(PicPlayer).ddsdSurface.lWidth, PlayerY + Player.RHand(PicPlayer).ddsdSurface.lHeight), Player.RHand(PicPlayer).Surface, ddRect(0, 0, 0, 0), DDBLT_KEYSRC Or DDBLT_DDFX Or DDBLT_WAIT, BltFxRevert
        End If
    Case "left hand"
        PlayerY = Player.PositionY.LHand
        If PlayerX < WickedX Then
            If PlayerX + 70 >= WickedX Then PlayerX = PlayerX - StepX
            Backbuffer.BltFast PlayerX, PlayerY, Player.LHand(PicPlayer).Surface, ddRect(0, 0, 0, 0), DDBLTFAST_SRCCOLORKEY Or DDBLTFAST_WAIT
        Else
            If PlayerX - 20 <= WickedX Then PlayerX = PlayerX - StepX
            Backbuffer.BltFx ddRect(PlayerX, PlayerY, PlayerX + Player.LHand(PicPlayer).ddsdSurface.lWidth, PlayerY + Player.LHand(PicPlayer).ddsdSurface.lHeight), Player.LHand(PicPlayer).Surface, ddRect(0, 0, 0, 0), DDBLT_KEYSRC Or DDBLT_DDFX Or DDBLT_WAIT, BltFxRevert
        End If
    Case "move"
        PlayerY = Player.PositionY.Move
        If PlayerX < WickedX Then
            If PlayerX + 70 >= WickedX Then PlayerX = PlayerX - StepX
            Backbuffer.BltFast PlayerX, PlayerY, Player.Move(PicPlayer).Surface, ddRect(0, 0, 0, 0), DDBLTFAST_SRCCOLORKEY Or DDBLTFAST_WAIT
        Else
            If PlayerX - 20 <= WickedX Then PlayerX = PlayerX - StepX
            Backbuffer.BltFx ddRect(PlayerX, PlayerY, PlayerX + Player.Move(PicPlayer).ddsdSurface.lWidth, PlayerY + Player.Move(PicPlayer).ddsdSurface.lHeight), Player.Move(PicPlayer).Surface, ddRect(0, 0, 0, 0), DDBLT_KEYSRC Or DDBLT_DDFX Or DDBLT_WAIT, BltFxRevert
        End If
    Case "defend"
        PlayerY = Player.PositionY.Defend
        If PlayerX < WickedX Then
            Backbuffer.BltFast PlayerX, PlayerY, Player.Defend(PicPlayer).Surface, ddRect(0, 0, 0, 0), DDBLTFAST_SRCCOLORKEY Or DDBLTFAST_WAIT
        Else
            Backbuffer.BltFx ddRect(PlayerX, PlayerY, PlayerX + Player.Defend(PicPlayer).ddsdSurface.lWidth, PlayerY + Player.Defend(PicPlayer).ddsdSurface.lHeight), Player.Defend(PicPlayer).Surface, ddRect(0, 0, 0, 0), DDBLT_KEYSRC Or DDBLT_DDFX Or DDBLT_WAIT, BltFxRevert
        End If
    Case "back"
        PlayerY = Player.PositionY.Back
        If PlayerX < WickedX Then
            Backbuffer.BltFast PlayerX, PlayerY, Player.Back(PicPlayer).Surface, ddRect(0, 0, 0, 0), DDBLTFAST_SRCCOLORKEY Or DDBLTFAST_WAIT
        Else
            Backbuffer.BltFx ddRect(PlayerX, PlayerY, PlayerX + Player.Back(PicPlayer).ddsdSurface.lWidth, PlayerY + Player.Back(PicPlayer).ddsdSurface.lHeight), Player.Back(PicPlayer).Surface, ddRect(0, 0, 0, 0), DDBLT_KEYSRC Or DDBLT_DDFX Or DDBLT_WAIT, BltFxRevert
        End If
    Case "wait"
        PlayerY = Player.PositionY.Wait
        If PlayerX < WickedX Then
            Backbuffer.BltFast PlayerX, PlayerY, Player.Wait(PicPlayer).Surface, ddRect(0, 0, 0, 0), DDBLTFAST_SRCCOLORKEY Or DDBLTFAST_WAIT
        Else
            Backbuffer.BltFx ddRect(PlayerX, PlayerY, PlayerX + Player.Wait(PicPlayer).ddsdSurface.lWidth, PlayerY + Player.Wait(PicPlayer).ddsdSurface.lHeight), Player.Wait(PicPlayer).Surface, ddRect(0, 0, 0, 0), DDBLT_KEYSRC Or DDBLT_DDFX Or DDBLT_WAIT, BltFxRevert
        End If
    Case "die"
        PlayerY = Player.PositionY.Die
        If PlayerX < WickedX Then
            Backbuffer.BltFast PlayerX, PlayerY, Player.Die(PicPlayer).Surface, ddRect(0, 0, 0, 0), DDBLTFAST_SRCCOLORKEY Or DDBLTFAST_WAIT
        Else
            Backbuffer.BltFx ddRect(PlayerX, PlayerY, PlayerX + Player.Die(PicPlayer).ddsdSurface.lWidth, PlayerY + Player.Die(PicPlayer).ddsdSurface.lHeight), Player.Die(PicPlayer).Surface, ddRect(0, 0, 0, 0), DDBLT_KEYSRC Or DDBLT_DDFX Or DDBLT_WAIT, BltFxRevert
        End If
    Case "special"
        PlayerY = Player.PositionY.Special
        If PicPlayer = 0 Then Player.SSpecial.Play DSBPLAY_DEFAULT
        If PlayerX < WickedX Then
            Backbuffer.BltFast PlayerX, PlayerY, Player.Special(PicPlayer).Surface, ddRect(0, 0, 0, 0), DDBLTFAST_SRCCOLORKEY Or DDBLTFAST_WAIT
        Else
            Backbuffer.BltFx ddRect(PlayerX, PlayerY, PlayerX + Player.Special(PicPlayer).ddsdSurface.lWidth, PlayerY + Player.Special(PicPlayer).ddsdSurface.lHeight), Player.Special(PicPlayer).Surface, ddRect(0, 0, 0, 0), DDBLT_KEYSRC Or DDBLT_DDFX Or DDBLT_WAIT, BltFxRevert
        End If
    End Select
End Sub

Public Sub DrawComWicked(StepX As Integer, StepY As Integer, MaxPic As Integer, Movement As String, comWickedState As String)
     WOneHit = False
    
    If ComWicked.State <> comWickedState Then
        ComWicked.State = comWickedState
        Wicked = 0
        WickedY = ComWicked.PositionY.Jump
        WOneHit = True
    End If
    
    If Wicked = MaxPic Then
        ComWicked.State = "w"
        Wicked = 0
    End If
    
    If StepX < 0 Then
        If WickedX - StepX > 20 Then
            WickedX = WickedX + StepX
        End If
    Else
        If (WickedX + 70 + StepX) < 710 Then
            WickedX = WickedX + StepX
        End If
    End If
    
    WickedY = WickedY + StepY
    
    If Wicked > MaxPic Then Wicked = 0
    
    Select Case Movement
    
    Case "jump"
        If WickedX < PlayerX Then
            Backbuffer.BltFast WickedX, WickedY, ComWicked.Jump(Wicked).Surface, ddRect(0, 0, 0, 0), DDBLTFAST_SRCCOLORKEY Or DDBLTFAST_WAIT
        Else
            Backbuffer.BltFx ddRect(WickedX, WickedY, WickedX + ComWicked.Jump(Wicked).ddsdSurface.lWidth, WickedY + ComWicked.Jump(Wicked).ddsdSurface.lHeight), ComWicked.Jump(Wicked).Surface, ddRect(0, 0, 0, 0), DDBLT_KEYSRC Or DDBLT_DDFX Or DDBLT_WAIT, BltFxRevert
        End If
    Case "right foot"
        WickedY = ComWicked.PositionY.RFoot
        If WickedX + 20 < PlayerX Then
            Backbuffer.BltFast WickedX, WickedY, ComWicked.RFoot(Wicked).Surface, ddRect(0, 0, 0, 0), DDBLTFAST_SRCCOLORKEY Or DDBLTFAST_WAIT
        Else
            Backbuffer.BltFx ddRect(WickedX, WickedY, WickedX + ComWicked.RFoot(Wicked).ddsdSurface.lWidth, WickedY + ComWicked.RFoot(Wicked).ddsdSurface.lHeight), ComWicked.RFoot(Wicked).Surface, ddRect(0, 0, 0, 0), DDBLT_KEYSRC Or DDBLT_DDFX Or DDBLT_WAIT, BltFxRevert
        End If
    Case "left foot"
        WickedY = ComWicked.PositionY.LFoot
        If WickedX < PlayerX Then
            Backbuffer.BltFast WickedX, WickedY, ComWicked.LFoot(Wicked).Surface, ddRect(0, 0, 0, 0), DDBLTFAST_SRCCOLORKEY Or DDBLTFAST_WAIT
        Else
            Backbuffer.BltFx ddRect(WickedX, WickedY, WickedX + ComWicked.LFoot(Wicked).ddsdSurface.lWidth, WickedY + ComWicked.LFoot(Wicked).ddsdSurface.lHeight), ComWicked.LFoot(Wicked).Surface, ddRect(0, 0, 0, 0), DDBLT_KEYSRC Or DDBLT_DDFX Or DDBLT_WAIT, BltFxRevert
        End If
    Case "right hand"
        WickedY = ComWicked.PositionY.RHand
        If WickedX < PlayerX Then
            Backbuffer.BltFast WickedX, WickedY, ComWicked.RHand(Wicked).Surface, ddRect(0, 0, 0, 0), DDBLTFAST_SRCCOLORKEY Or DDBLTFAST_WAIT
        Else
            Backbuffer.BltFx ddRect(WickedX, WickedY, WickedX + ComWicked.RHand(Wicked).ddsdSurface.lWidth, WickedY + ComWicked.RHand(Wicked).ddsdSurface.lHeight), ComWicked.RHand(Wicked).Surface, ddRect(0, 0, 0, 0), DDBLT_KEYSRC Or DDBLT_DDFX Or DDBLT_WAIT, BltFxRevert
        End If
    Case "left hand"
        WickedY = ComWicked.PositionY.LHand
        If WickedX < PlayerX Then
            Backbuffer.BltFast WickedX, WickedY, ComWicked.LHand(Wicked).Surface, ddRect(0, 0, 0, 0), DDBLTFAST_SRCCOLORKEY Or DDBLTFAST_WAIT
        Else
            Backbuffer.BltFx ddRect(WickedX, WickedY, WickedX + ComWicked.LHand(Wicked).ddsdSurface.lWidth, WickedY + ComWicked.LHand(Wicked).ddsdSurface.lHeight), ComWicked.LHand(Wicked).Surface, ddRect(0, 0, 0, 0), DDBLT_KEYSRC Or DDBLT_DDFX Or DDBLT_WAIT, BltFxRevert
        End If
    Case "move"
        WickedY = ComWicked.PositionY.Move
        If WickedX < PlayerX Then
            Backbuffer.BltFast WickedX, WickedY, ComWicked.Move(Wicked).Surface, ddRect(0, 0, 0, 0), DDBLTFAST_SRCCOLORKEY Or DDBLTFAST_WAIT
        Else
            Backbuffer.BltFx ddRect(WickedX, WickedY, WickedX + ComWicked.Move(Wicked).ddsdSurface.lWidth, WickedY + ComWicked.Move(Wicked).ddsdSurface.lHeight), ComWicked.Move(Wicked).Surface, ddRect(0, 0, 0, 0), DDBLT_KEYSRC Or DDBLT_DDFX Or DDBLT_WAIT, BltFxRevert
        End If
    Case "defend"
        WickedY = ComWicked.PositionY.Defend
        If WickedX < PlayerX Then
            Backbuffer.BltFast WickedX, WickedY, ComWicked.Defend(Wicked).Surface, ddRect(0, 0, 0, 0), DDBLTFAST_SRCCOLORKEY Or DDBLTFAST_WAIT
        Else
            Backbuffer.BltFx ddRect(WickedX, WickedY, WickedX + ComWicked.Defend(Wicked).ddsdSurface.lWidth, WickedY + ComWicked.Defend(Wicked).ddsdSurface.lHeight), ComWicked.Defend(Wicked).Surface, ddRect(0, 0, 0, 0), DDBLT_KEYSRC Or DDBLT_DDFX Or DDBLT_WAIT, BltFxRevert
        End If
    Case "back"
        WickedY = ComWicked.PositionY.Back
        If WickedX < PlayerX Then
            Backbuffer.BltFast WickedX, WickedY, ComWicked.Back(Wicked).Surface, ddRect(0, 0, 0, 0), DDBLTFAST_SRCCOLORKEY Or DDBLTFAST_WAIT
        Else
            Backbuffer.BltFx ddRect(WickedX, WickedY, WickedX + ComWicked.Back(Wicked).ddsdSurface.lWidth, WickedY + ComWicked.Back(Wicked).ddsdSurface.lHeight), ComWicked.Back(Wicked).Surface, ddRect(0, 0, 0, 0), DDBLT_KEYSRC Or DDBLT_DDFX Or DDBLT_WAIT, BltFxRevert
        End If
    Case "wait"
        WickedY = ComWicked.PositionY.Wait
        If WickedX < PlayerX Then
            Backbuffer.BltFast WickedX, WickedY, ComWicked.Wait(Wicked).Surface, ddRect(0, 0, 0, 0), DDBLTFAST_SRCCOLORKEY Or DDBLTFAST_WAIT
        Else
            Backbuffer.BltFx ddRect(WickedX, WickedY, WickedX + ComWicked.Wait(Wicked).ddsdSurface.lWidth, WickedY + ComWicked.Wait(Wicked).ddsdSurface.lHeight), ComWicked.Wait(Wicked).Surface, ddRect(0, 0, 0, 0), DDBLT_KEYSRC Or DDBLT_DDFX Or DDBLT_WAIT, BltFxRevert
        End If
    Case "die"
        WickedY = ComWicked.PositionY.Die
        If WickedX < PlayerX Then
            Backbuffer.BltFast WickedX, WickedY, ComWicked.Die(Wicked).Surface, ddRect(0, 0, 0, 0), DDBLTFAST_SRCCOLORKEY Or DDBLTFAST_WAIT
        Else
            Backbuffer.BltFx ddRect(WickedX, WickedY, WickedX + ComWicked.Die(Wicked).ddsdSurface.lWidth, WickedY + ComWicked.Die(Wicked).ddsdSurface.lHeight), ComWicked.Die(Wicked).Surface, ddRect(0, 0, 0, 0), DDBLT_KEYSRC Or DDBLT_DDFX Or DDBLT_WAIT, BltFxRevert
        End If
    Case "special"
        WickedY = ComWicked.PositionY.Special
        If WickedX < PlayerX Then
            Backbuffer.BltFast WickedX, WickedY, ComWicked.Special(Wicked).Surface, ddRect(0, 0, 0, 0), DDBLTFAST_SRCCOLORKEY Or DDBLTFAST_WAIT
        Else
            Backbuffer.BltFx ddRect(WickedX, WickedY, WickedX + ComWicked.Special(Wicked).ddsdSurface.lWidth, WickedY + ComWicked.Special(Wicked).ddsdSurface.lHeight), ComWicked.Special(Wicked).Surface, ddRect(0, 0, 0, 0), DDBLT_KEYSRC Or DDBLT_DDFX Or DDBLT_WAIT, BltFxRevert
        End If
    End Select
End Sub

Public Function CheckWOnP() As Boolean
    If (WickedX - 110) < PlayerX And PlayerX < WickedX Then
        CheckWOnP = True
    ElseIf WickedX < PlayerX And PlayerX < (WickedX + 180) Then
        CheckWOnP = True
    Else
        CheckWOnP = False
    End If
End Function

Public Function Restart()
    bRunning = False
    Player.State = "w"
    ComWicked.State = "w"
    WickedLife = 500
    PlayerLife = 300
    RoundStart = True
    Player.State = "w"
    ComWicked.State = "w"
    RoundEnd = False
    Call perf.Stop(MusicBattle, segstate, 0, 0)
    Call PersoScreen
End Function

Public Function Ending()
    Call ErasePerso(Player)
    Call ErasePerso(ComWicked)
    bScreenPerso = False
    dd.RestoreDisplayMode
    Set Primary = Nothing
    Set Backbuffer = Nothing
    Set dd = Nothing
    Set dx = Nothing
    Set DI = Nothing
    Set DS = Nothing
    Set MusicTheme = Nothing
    Set MusicBattle = Nothing
    End
End Function
